/*------------------------------------------------------------------------
    File        : he-conversion-01.p
    Author(s)   : Fred
    Created     : 19/02/2020
    Notes       : he-stock-main.txt   Hendrick European
 ----------------------------------------------------------------------*/

 DEFINE INPUT PARAMETER piQuayjobid AS INTEGER NO-UNDO.
 DEFINE INPUT PARAMETER pcFilename AS CHARACTER NO-UNDO.


 DEFINE NEW GLOBAL SHARED VARIABLE sp-companycode          AS CHAR   NO-UNDO.
 DEFINE NEW GLOBAL SHARED VARIABLE sp-userid               AS CHAR   NO-UNDO.


  /****************************  Main Block  *************************** */



  DEFINE BUFFER b-dp-quayjob_baplie FOR dp-quayjob_baplie.


  DEFINE STREAM strInput.


DEFINE VARIABLE cFilename           AS CHARACTER NO-UNDO.
DEFINE VARIABLE cLine               AS CHARACTER NO-UNDO.
DEFINE VARIABLE cHeader             AS CHARACTER NO-UNDO.
DEFINE VARIABLE cValue              AS CHARACTER NO-UNDO.
DEFINE VARIABLE lOk                 AS LOGICAL   NO-UNDO.
DEFINE VARIABLE iLine               AS INTEGER   NO-UNDO.
DEFINE VARIABLE iCol                AS INTEGER   NO-UNDO.
DEFINE VARIABLE iPos                AS INTEGER   NO-UNDO.
DEFINE VARIABLE cCustomer           AS CHARACTER NO-UNDO.
DEFINE VARIABLE cSubCustomer        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cCustomsStatus      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cContainernumber    AS CHARACTER NO-UNDO.
DEFINE VARIABLE cPrefix             AS CHARACTER NO-UNDO.
DEFINE VARIABLE cNumber             AS CHARACTER NO-UNDO.
DEFINE VARIABLE cDateTimeIn         AS CHARACTER NO-UNDO.
DEFINE VARIABLE cDateIn             AS CHARACTER NO-UNDO.
DEFINE VARIABLE cTimeIn             AS CHARACTER NO-UNDO.
DEFINE VARIABLE cLocation           AS CHARACTER NO-UNDO.
DEFINE VARIABLE cBookingnumber      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cContainertype      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cFullEmptycode      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cCycluscode         AS CHARACTER NO-UNDO.
DEFINE VARIABLE cGrossWeight        AS CHARACTER NO-UNDO.
DEFINE VARIABLE iGrossWeight        AS INTEGER   NO-UNDO.
DEFINE VARIABLE iVgm                AS INTEGER   NO-UNDO.
DEFINE VARIABLE cVGM                AS CHARACTER NO-UNDO.
DEFINE VARIABLE cImo                AS CHARACTER NO-UNDO.
DEFINE VARIABLE cPlugin             AS CHARACTER NO-UNDO.
DEFINE VARIABLE cGoods              AS CHARACTER NO-UNDO.
DEFINE VARIABLE cRemarks            AS CHARACTER NO-UNDO.
DEFINE VARIABLE cUnnr               AS CHARACTER NO-UNDO.
DEFINE VARIABLE cInDoctype          AS CHARACTER NO-UNDO.
DEFINE VARIABLE cInDocNumber        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cOutDoctype         AS CHARACTER NO-UNDO.
DEFINE VARIABLE cOutDocNumber       AS CHARACTER NO-UNDO.
DEFINE VARIABLE cColumns            AS CHARACTER NO-UNDO.
DEFINE VARIABLE cColumn             AS CHARACTER NO-UNDO.
DEFINE VARIABLE cPol                AS CHARACTER NO-UNDO.
DEFINE VARIABLE cPod                AS CHARACTER NO-UNDO.
DEFINE VARIABLE cFinalpod           AS CHARACTER NO-UNDO.
DEFINE VARIABLE cDamaged            AS CHARACTER NO-UNDO.
DEFINE VARIABLE cSealNumber         AS CHARACTER NO-UNDO.
DEFINE VARIABLE cOrgDocTypes        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cNewDocTypes        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cTemperature        AS CHARACTER NO-UNDO.
DEFINE VARIABLE dTemperature        AS DECIMAL   NO-UNDO.
DEFINE VARIABLE cInTransportCompany AS CHARACTER NO-UNDO.
DEFINE VARIABLE cInLicensePlate     AS CHARACTER NO-UNDO.
DEF VAR cOutBookingNumber AS CHAR NO-UNDO.
DEF VAR cCustCode AS CHAR NO-UNDO.
DEF VAR cJobNr AS CHAR NO-UNDO.


  cColumns = "A,B,C,D,E,F,G,H,I,J,K,L".

  PUBLISH 'dpConversionCounter' ("start",0).

  /*--- clean up ---*/
  DO TRANSACTION:
    FOR EACH b-dp-quayjob_baplie EXCLUSIVE-LOCK WHERE
             b-dp-quayjob_baplie.companycode = sp-companycode AND
             b-dp-quayjob_baplie.quayjobid = piQuayjobid :
      DELETE b-dp-quayjob_baplie.
    END.
  END.

  /*--- convert stock main ---*/
  cFilename = pcFilename.

  INPUT STREAM strInput FROM VALUE(cFilename).

  iLine = 0.
  IMPORTFILE:
  REPEAT:
    ASSIGN lOK = FALSE.
    DO:
    /* DO ON ERROR UNDO IMPORTFILE,LEAVE IMPORTFILE:*/
      lOK = TRUE.
      IMPORT STREAM strInput UNFORMATTED cLine.
      cLine = CAPS(cLine).
      cLine = REPLACE (cLine,",","").
      cLine = REPLACE (cLine,"=","").
      iLine = iLine + 1.
      IF iLine MODULO 100 = 0 THEN PUBLISH 'dpConversionCounter' ("COUNT",iLine).
      IF iLine = 1
      THEN DO:
        ASSIGN cHeader = cLIne.
      END.
      ELSE DO:
        DO iCol = 1 TO NUM-ENTRIES(cLine, CHR(9)):
          cColumn = ENTRY(iCol,cColumns).
          cValue = ENTRY(iCol,cLine,CHR(9)).

          IF cColumn = "A" THEN ASSIGN cJobNr = cValue.
          IF cColumn = "B" THEN ASSIGN cContainernumber = cValue.
          IF cColumn = "C" THEN ASSIGN cCustomer = cValue.
          IF cColumn = "D" THEN ASSIGN cContainertype = cValue.
          IF cColumn = "E" THEN ASSIGN cDateIn = cValue.
          IF cColumn = "F" THEN ASSIGN cTimeIn = cValue.
          IF cColumn = "G" THEN ASSIGN cInTransportCompany = cValue.
          IF cColumn = "H" THEN ASSIGN cInLicensePlate = cValue.
          IF cColumn = "I" THEN ASSIGN cOutBookingNumber = cValue.
          IF cColumn = "J" THEN ASSIGN cCustCode = cValue.
          IF cColumn = "K" THEN ASSIGN cRemarks = cValue.
          IF cColumn = "L" THEN ASSIGN cDamaged = cValue.

        END.

        cFullEmptycode = "E".

        cContainernumber = REPLACE(cContainernumber," ","").
        cContainernumber = REPLACE(cContainernumber,"-","").

        IF cContainernumber = ""
        THEN DO:
          MESSAGE "Line " iLine " has no container number! This line will be skipped!".
          NEXT IMPORTFILE.
        END.

        cPrefix = SUBSTRING(cContainernumber,1,4).
        cNumber = SUBSTRING(cContainernumber,5).

        /* 2015-02-12 14:18:34 */
        cTimeIn =  REPLACE(cTimeIn,":","").

        IF cDamaged <> "yes"
        THEN cDamaged = "no".

        cRemarks = "Conversion=YES"
                 + ",JobNr=" + cJobNr
                 + ",Damaged=" + cDamaged
                 + ",InDate=" + cDateIn
                 + ",InTime=" + cTimeIn
                 + ",Haulier_in=" + cInTransportCompany
                 + ",licenseplate_in=" + cInLicensePlate
                 + ",release_ref=" + cOutBookingNumber
                 + ",Remarks=" + cRemarks
                 + ",customerCode=" + cCustCode
                 .


        DO TRANSACTION:

          CREATE b-dp-quayjob_baplie.
          ASSIGN b-dp-quayjob_baplie.companycode            = sp-companycode
                 b-dp-quayjob_baplie.quayjobid              = piQuayjobid
                 b-dp-quayjob_baplie.recordtype             = "IN"
                 b-dp-quayjob_baplie.edi_sender             = "HE-CONVERSIE"
                 b-dp-quayjob_baplie.bapliesyntax           = "BAPLIE" /* placeholder for cMessageFormat */
                 b-dp-quayjob_baplie.baplie_seqnr           = iLine
                 b-dp-quayjob_baplie.carrier                = TRIM(cCustomer)
                 b-dp-quayjob_baplie.subcustomer            = cSubCustomer
                 b-dp-quayjob_baplie.containerprefix        = cPrefix
                 b-dp-quayjob_baplie.containernumber        = cNumber
                 b-dp-quayjob_baplie.fullemptycode          = cFullEmptycode
                 b-dp-quayjob_baplie.goods                  = cRemarks
                 b-dp-quayjob_baplie.customs_status         = cCustomsStatus
                 b-dp-quayjob_baplie.pincode                = ""
                 b-dp-quayjob_baplie.imoclass               = ""
                 b-dp-quayjob_baplie.unnr                   = cUnnr
                 b-dp-quayjob_baplie.isotype                = cContainerType
                 b-dp-quayjob_baplie.pol                    = cPol
                 b-dp-quayjob_baplie.pol_terminal           = ""
                 b-dp-quayjob_baplie.pod                    = "NLRTM"
                 b-dp-quayjob_baplie.pod_terminal           = ""
                 b-dp-quayjob_baplie.final_pod              = cFinalpod
                 b-dp-quayjob_baplie.sealnumber             = cSealNumber
                 b-dp-quayjob_baplie.stowlocation           = ""
                 b-dp-quayjob_baplie.reeferplugin           = cPlugin
                 b-dp-quayjob_baplie.temperature            = 0
                 b-dp-quayjob_baplie.weight                 = iGrossweight
                 b-dp-quayjob_baplie.verified_grossweight   = iVGM
                 b-dp-quayjob_baplie.bookingnumber          = cBookingnumber
                 .
         END.
      END.
    END.
  END.

  INPUT STREAM strInput CLOSE.

  PUBLISH 'dpConversionCounter' ("end",0).
