/*------------------------------------------------------------------------
    File        : he-post-conversion-01.p
    Author(s)   : Fred
    Created     : 06/04/2020
    Notes       : update container record + update move records met correcte datum / tijd
 ----------------------------------------------------------------------*/



  DEFINE NEW GLOBAL SHARED VARIABLE sp-companycode          AS CHAR   NO-UNDO.
  DEFINE NEW GLOBAL SHARED VARIABLE sp-userid               AS CHAR   NO-UNDO.




  DEF VAR dtIn       AS DATE    NO-UNDO.
  DEF VAR cField     AS CHAR    NO-UNDO.
  DEF VAR cValue     AS CHAR    NO-UNDO.
  DEF VAR cData      AS CHAR    NO-UNDO.
  DEF VAR cMsg       AS CHAR    NO-UNDO.
  DEF VAR cErrorMsg  AS CHAR    NO-UNDO.
  DEF VAR iLine      AS INTEGER NO-UNDO.
  DEF VAR iLoop      AS INTEGER NO-UNDO.
  DEF VAR iTeller    AS INTEGER NO-UNDO.

  DEF BUFFER b-dp-container FOR dp-container.
  DEF BUFFER b-dp-move FOR dp-move.
  DEF BUFFER b-dp-delivery FOR dp-delivery.


  FOR EACH b-dp-container WHERE
           b-dp-container.companycode = sp-companycode AND
           b-dp-container.recordtype = "30" AND
           b-dp-container.des_goods BEGINS "conversion="
           /*b-dp-container.in_quayjobid = 101852 */
           EXCLUSIVE-LOCK:

    iTeller = iTeller + 1.
    IF iTeller = 0 OR iTeller MODULO 100 = 0
    THEN PUBLISH 'spRecordCounter' (iTeller).

    ASSIGN b-dp-container.deliveryid = 0
           b-dp-container.cycluscode = ""
           b-dp-container.statuscode = "AV".

    cData = b-dp-container.des_goods.

    cData = REPLACE(cData,"=",",").

    DO iLoop = 1 TO NUM-ENTRIES(cData) BY 2.
      cField = ENTRY(iLoop,cData).
      cValue = ENTRY(iLoop + 1,cData).

      CASE cField:
        WHEN "conversion"
        THEN DO:
          b-dp-container.out_remarks = b-dp-container.des_goods.
        END.
        WHEN "damaged"
        THEN DO:
           IF cValue = "yes"
           THEN ASSIGN b-dp-container.statuscode = "AI"
                       b-dp-container.damagestatus = "Y".
        END.
        WHEN "InDate"
        THEN DO:
          b-dp-container.dt_in = DATE(cValue).
        END.
        WHEN "InTime"
        THEN DO:
          b-dp-container.tim_in = cValue.
        END.
        WHEN "Haulier_in"
        THEN b-dp-container.in_transportcompany = cValue.
        WHEN "licenseplate_in"
        THEN b-dp-container.in_license_plate = cValue.
        WHEN "remarks"
        THEN b-dp-container.in_remarks = cValue.
        WHEN "customercode"
        THEN . /* Just to keep it in the remarks */
        WHEN "release_ref" OR WHEN "jobnr"
        THEN DO:

          FIND b-dp-delivery WHERE
               b-dp-delivery.companycode = sp-companycode AND
               b-dp-delivery.deliverynumber = cValue AND
               b-dp-delivery.bookingtype = "2" AND
               b-dp-delivery.cust_addressnr = b-dp-delivery.cust_addressnr AND
               b-dp-delivery.containertype = b-dp-container.containertype AND
               b-dp-delivery.container_statuscode = "AV" AND
               b-dp-delivery.booking_statuscode = "OPEN" AND
               b-dp-delivery.fullemptycode = "E"
               EXCLUSIVE-LOCK NO-ERROR.

          IF NOT AVAIL b-dp-delivery
          THEN DO:
            CREATE b-dp-delivery.
            ASSIGN b-dp-delivery.companycode = sp-companycode
                   b-dp-delivery.deliverynumber = cValue
                   b-dp-delivery.bookingtype = "2"
                   b-dp-delivery.depotcode = "01"
                   b-dp-delivery.cust_addressnr = b-dp-delivery.cust_addressnr
                   b-dp-delivery.deliveryid = NEXT-VALUE(dp-deliveryid)
                   b-dp-delivery.containertype = b-dp-container.containertype
                   b-dp-delivery.container_statuscode = "AV"
                   b-dp-delivery.booking_statuscode = "OPEN"
                   b-dp-delivery.fullemptycode = "E"
                   b-dp-delivery.create_usercode = "SOFTPAK"
                   b-dp-delivery.dt_create = TODAY
                   .
          END.

          b-dp-delivery.nr_booked  = b-dp-delivery.nr_booked + 1.
          b-dp-container.deliveryid = b-dp-delivery.deliveryid.
        END.

        OTHERWISE DO:
          MESSAGE "Unknown entry " cField " in conversion data string".
        END.
      END CASE.
    END. /* do iloop */



    /* update moves */

    FIND b-dp-move WHERE
         b-dp-move.companycode = sp-companycode AND
         b-dp-move.seqnr       = b-dp-container.seqnr AND
         b-dp-move.movecode   = "01"
         EXCLUSIVE-LOCK.

    ASSIGN b-dp-move.dt_move   = b-dp-container.dt_in
           b-dp-move.dt_create = b-dp-container.dt_in
           b-dp-move.tim_move   = b-dp-container.tim_in
           b-dp-move.tim_create = b-dp-container.tim_in
           .

    FIND b-dp-move WHERE
         b-dp-move.companycode = sp-companycode AND
         b-dp-move.seqnr       = b-dp-container.seqnr AND
         b-dp-move.movecode   = "02"
         EXCLUSIVE-LOCK.

    ASSIGN b-dp-move.dt_move   = b-dp-container.dt_in
           b-dp-move.dt_create = b-dp-container.dt_in
           b-dp-move.tim_move   = b-dp-container.tim_in
           b-dp-move.tim_create = b-dp-container.tim_in
           .



END. /* FOR EACH */

PUBLISH 'spRecordCounter' (iTeller).


iTeller = 0 .

/* verwijderen automatisch aangemaakte (relocate / document added) moves */
FOR EACH b-dp-container WHERE
         b-dp-container.companycode = sp-companycode AND
         b-dp-container.recordtype = "30" AND
         b-dp-container.depotcode = "04"
         EXCLUSIVE-LOCK:

  iTeller = iTeller + 1.
  IF iTeller = 0 OR iTeller MODULO 100 = 0
  THEN PUBLISH 'spRecordCounter' (iTeller).
  FOR EACH b-dp-move WHERE
           b-dp-move.companycode = sp-companycode AND
           b-dp-move.seqnr = b-dp-container.seqnr
           EXCLUSIVE-LOCK:
    IF b-dp-move.movecode = "39" /* relocate */  OR b-dp-move.movecode = "137" /* doc. added */
    THEN DO:
      DELETE b-dp-move.
    END.
  END.
END.

PUBLISH 'spRecordCounter' (iTeller).


IF cErrorMsg <> ""
THEN DO:
  MESSAGE cErrorMsg.
END.

MESSAGE "Finito".



